﻿Imports System.Resources
Imports VSGridMapF45
Imports VSGridMapF45.ClsPsysCell

Public Class FrmMain

    Private Sub CmdLoadJSON_Click(sender As Object, e As EventArgs) Handles CmdLoadJSON.Click

        Dim jsonStr As String = ""
        jsonStr += "{" & vbCrLf
        jsonStr += "  ""Type"": ""BackGroundMap""," & vbCrLf
        jsonStr += "  ""Items"": [" & vbCrLf
        jsonStr += "    {""IniPosX"": 1, ""IniPosY"": 1,  ""EndPosX"": 4,  ""EndPosY"": 4,  ""BackColorHTML"": ""#FF3366""}," & vbCrLf
        jsonStr += "    {""IniPosX"": 5, ""IniPosY"": 5,  ""EndPosX"": 10, ""EndPosY"": 7,  ""BackColorHTML"": ""#3333CC""}," & vbCrLf
        jsonStr += "    {""IniPosX"": 3, ""IniPosY"": 10, ""EndPosX"": 15, ""EndPosY"": 13, ""BackColorHTML"": ""#66ff99""}" & vbCrLf
        jsonStr += "  ]" & vbCrLf
        jsonStr += "}" & vbCrLf

        PsysGridMap1.BackgroundMapJSON = jsonStr
        PsysGridMap1.Redraw()

    End Sub

    Private Sub CmdLoadXML_Click(sender As Object, e As EventArgs) Handles CmdLoadXML.Click

        Dim xmlStr As String
        xmlStr = ""
        xmlStr += "<?xml version=""1.0"" encoding=""utf-16""?>" & vbCrLf
        xmlStr += "<ClsBackgroundGrid xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">" & vbCrLf
        xmlStr += "  <Type>BackgroundGrid</Type>" & vbCrLf
        xmlStr += "  <Items>" & vbCrLf
        xmlStr += "    <ClsBackgroundGridItem>" & vbCrLf
        xmlStr += "      <IniPosX>1</IniPosX>" & vbCrLf
        xmlStr += "      <IniPosY>1</IniPosY>" & vbCrLf
        xmlStr += "      <EndPosX>4</EndPosX>" & vbCrLf
        xmlStr += "      <EndPosY>3</EndPosY>" & vbCrLf
        xmlStr += "      <BackColorHTML>#ff6699</BackColorHTML>" & vbCrLf
        xmlStr += "    </ClsBackgroundGridItem>" & vbCrLf
        xmlStr += "    <ClsBackgroundGridItem>" & vbCrLf
        xmlStr += "      <IniPosX>4</IniPosX>" & vbCrLf
        xmlStr += "      <IniPosY>1</IniPosY>" & vbCrLf
        xmlStr += "      <EndPosX>5</EndPosX>" & vbCrLf
        xmlStr += "      <EndPosY>5</EndPosY>" & vbCrLf
        xmlStr += "      <BackColorHTML>#cc6600</BackColorHTML>" & vbCrLf
        xmlStr += "    </ClsBackgroundGridItem>" & vbCrLf
        xmlStr += "  </Items>" & vbCrLf
        xmlStr += "</ClsBackgroundGrid>"

        PsysGridMap1.BackgroundMapXML = xmlStr
        PsysGridMap1.Redraw()

    End Sub

    Private Sub CmdLoadCells_Click(sender As Object, e As EventArgs) Handles CmdLoadCells.Click

        With PsysGridMap1
            .DraggingActive = False
            .CellsTitleAlign = ContentAlignment.TopLeft
            .BackgroundImageLayout = ImageLayout.None
            For xx = 1 To 5
                For yy = 1 To 5
                    .SetCell(xx.ToString & "," & yy.ToString, xx, yy, xx.ToString & "," & yy.ToString)
                    .GetCell(xx, yy).CellBackColor = Color.White
                    .GetCell(xx, yy).CellForeColor = Color.Black
                Next yy
            Next xx

            .GetCell(2, 2).CornerNote = True
            .GetCell(2, 2).CornerSize = 6
            .GetCell(2, 2).CornerPosition = EnumCornerPosition.LeftTop

            .GetCell(4, 2).CornerNote = True
            .GetCell(4, 2).CornerSize = 6
            .GetCell(4, 2).CornerPosition = EnumCornerPosition.RightTop
            .GetCell(4, 2).CornerColor = System.Drawing.Color.Red

            .GetCell(2, 4).CornerNote = True
            .GetCell(2, 4).CornerSize = 6
            .GetCell(2, 4).CornerPosition = EnumCornerPosition.LeftBottom

            .GetCell(4, 4).CornerNote = True
            .GetCell(4, 4).CornerSize = 6
            .GetCell(4, 4).CornerPosition = EnumCornerPosition.RightBottom
            .GetCell(4, 4).CornerColor = System.Drawing.Color.Green

            .Redraw()
        End With

        Dim oCell As New ClsPsysCell
        With oCell
            .CellX = 7
            .CellY = 4
            .ID = "myID"
            .Title = "Obj"
            .Data = Me
            .CellBackColor = Color.Bisque
            .CellForeColor = Color.Black
            .CornerNote = True
            .CornerSize = 7
            .CornerPosition = EnumCornerPosition.RightTop
            .CornerColor = Color.Red
        End With
        PsysGridMap1.SetCell(oCell)

    End Sub

    Private Sub CmdRemoveAll_Click(sender As Object, e As EventArgs) Handles CmdRemoveAll.Click
        PsysGridMap1.RemoveAllCells()
    End Sub

    Private Sub CmdBackgroungCell_Click(sender As Object, e As EventArgs) Handles CmdBackgroungCell.Click

        If PsysGridMap1.GetCell(1, 1) IsNot Nothing Then
            PsysGridMap1.GetCell(1, 1).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(1, 1).CellBackgroundImagePosition = ContentAlignment.TopLeft
        End If
        If PsysGridMap1.GetCell(3, 1) IsNot Nothing Then
            PsysGridMap1.GetCell(3, 1).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(3, 1).CellBackgroundImagePosition = ContentAlignment.TopCenter
        End If
        If PsysGridMap1.GetCell(5, 1) IsNot Nothing Then
            PsysGridMap1.GetCell(5, 1).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(5, 1).CellBackgroundImagePosition = ContentAlignment.TopRight
        End If

        If PsysGridMap1.GetCell(1, 3) IsNot Nothing Then
            PsysGridMap1.GetCell(1, 3).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(1, 3).CellBackgroundImagePosition = ContentAlignment.MiddleLeft
        End If
        If PsysGridMap1.GetCell(3, 3) IsNot Nothing Then
            PsysGridMap1.GetCell(3, 3).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(3, 3).CellBackgroundImagePosition = ContentAlignment.MiddleCenter
        End If
        If PsysGridMap1.GetCell(5, 3) IsNot Nothing Then
            PsysGridMap1.GetCell(5, 3).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(5, 3).CellBackgroundImagePosition = ContentAlignment.MiddleRight
        End If

        If PsysGridMap1.GetCell(1, 5) IsNot Nothing Then
            PsysGridMap1.GetCell(1, 5).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(1, 5).CellBackgroundImagePosition = ContentAlignment.BottomLeft
        End If
        If PsysGridMap1.GetCell(3, 5) IsNot Nothing Then
            PsysGridMap1.GetCell(3, 5).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(3, 5).CellBackgroundImagePosition = ContentAlignment.BottomCenter
        End If
        If PsysGridMap1.GetCell(5, 5) IsNot Nothing Then
            PsysGridMap1.GetCell(5, 5).CellBackgroundImage = PicBgCell.Image
            PsysGridMap1.GetCell(5, 5).CellBackgroundImagePosition = ContentAlignment.BottomRight
        End If

        PsysGridMap1.Redraw()

    End Sub

    Private Sub PsysGridMap1_Open() Handles PsysGridMap1.Open

        '### SET LICENSE ###
        With PsysGridMap1
            .LicenseName = "Your Name"
            .LicenseAddress = "Your Address"
            .LicenseCity = "Your City"
            .LicenseCode = "XXXXXX-XXXXXX-XXXXXX-XXXXXX"
        End With

    End Sub

    Private Sub CmdBeach_Click(sender As Object, e As EventArgs) Handles CmdBeach.Click

        With PsysGridMap1
            .RemoveAllCells()
            .CellsTitleAlign = ContentAlignment.TopLeft
            .MapBackColor = Color.Beige
            .ForeColor = Color.Black
            Dim f As New Font(Me.Font.FontFamily, 7)
            .CellsFont = f
            .TotalCellsX = 29
            .TotalCellsY = 20
            .CellWidth = 25
            .CellHeight = 25
        End With

        '### Load a BackgroundMap from a JSON string ###
        Dim jStr As String = ""
        jStr = jStr + "{" + vbCrLf
        jStr = jStr + "  ""Type"": ""BackGroundMap""," + vbCrLf
        jStr = jStr + "  ""Items"": [" + vbCrLf
        jStr = jStr + "    {""IniPosX"": 1, ""IniPosY"": 1,  ""EndPosX"": 29,  ""EndPosY"": 2,  ""BackColorHTML"": ""#C1F0FE""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 10, ""IniPosY"": 3,  ""EndPosX"": 15, ""EndPosY"": 3,  ""BackColorHTML"": ""#C1F0FE""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 25, ""IniPosY"": 3,  ""EndPosX"": 29, ""EndPosY"": 3,  ""BackColorHTML"": ""#C1F0FE""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 10, ""IniPosY"": 7, ""EndPosX"": 11, ""EndPosY"": 20, ""BackColorHTML"": ""#E0E6E6""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 19, ""IniPosY"": 7, ""EndPosX"": 20, ""EndPosY"": 20, ""BackColorHTML"": ""#E0E6E6""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 1, ""IniPosY"": 19, ""EndPosX"": 29, ""EndPosY"": 20, ""BackColorHTML"": ""#E0E6E6""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 10, ""IniPosY"": 15, ""EndPosX"": 20, ""EndPosY"": 20, ""BackColorHTML"": ""#E0E6E6""}," + vbCrLf
        jStr = jStr + "    {""IniPosX"": 12, ""IniPosY"": 17, ""EndPosX"": 18, ""EndPosY"": 20, ""BackColorHTML"": ""#A97735""}" + vbCrLf
        jStr = jStr + "  ]" + vbCrLf
        jStr = jStr + "}" + vbCrLf
        PsysGridMap1.BackgroundMapJSON = jStr


        '### Load a some Cells ###

        Dim cRed As Color = Color.IndianRed
        Dim cGreen As Color = Color.LightGreen

        With PsysGridMap1
            .SetCell(1, 2, 17, "1").CellBackColor = cGreen
            .SetCell(2, 4, 17, "2").CellBackColor = cRed
            .SetCell(3, 6, 17, "3").CellBackColor = cGreen
            .SetCell(4, 8, 17, "4").CellBackColor = cRed
            .SetCell(5, 2, 15, "5").CellBackColor = cRed
            .SetCell(6, 4, 15, "6").CellBackColor = cRed
            .SetCell(7, 6, 15, "7").CellBackColor = cGreen
            .SetCell(8, 8, 15, "8").CellBackColor = cGreen
            .SetCell(9, 2, 13, "9").CellBackColor = cGreen
            .SetCell(10, 4, 13, "10").CellBackColor = cGreen
            .SetCell(11, 6, 13, "11").CellBackColor = cGreen
            .SetCell(12, 8, 13, "12").CellBackColor = cRed
            .SetCell(13, 2, 11, "13").CellBackColor = cRed
            .SetCell(14, 4, 11, "14").CellBackColor = cRed
            .SetCell(15, 6, 11, "15").CellBackColor = cGreen
            .SetCell(16, 8, 11, "16").CellBackColor = cGreen
            .SetCell(17, 2, 9, "17").CellBackColor = cGreen
            .SetCell(18, 4, 9, "18").CellBackColor = cGreen
            .SetCell(19, 6, 9, "19").CellBackColor = cRed
            .SetCell(20, 8, 9, "20").CellBackColor = cRed
            .SetCell(21, 2, 7, "21").CellBackColor = cRed
            .SetCell(22, 4, 7, "22").CellBackColor = cGreen
            .SetCell(23, 6, 7, "23").CellBackColor = cGreen
            .SetCell(24, 8, 7, "24").CellBackColor = cGreen

            .SetCell(25, 13, 7, "25").CellBackColor = cGreen
            .SetCell(26, 15, 7, "26").CellBackColor = cRed
            .SetCell(27, 17, 7, "27").CellBackColor = cRed
            .SetCell(28, 13, 9, "28").CellBackColor = cGreen
            .SetCell(29, 15, 9, "29").CellBackColor = cGreen
            .SetCell(30, 17, 9, "30").CellBackColor = cGreen
            .SetCell(31, 13, 11, "31").CellBackColor = cGreen
            .SetCell(32, 15, 11, "32").CellBackColor = cRed
            .SetCell(33, 17, 11, "33").CellBackColor = cRed
            .SetCell(34, 13, 13, "34").CellBackColor = cRed
            .SetCell(35, 15, 13, "35").CellBackColor = cGreen
            .SetCell(36, 17, 13, "36").CellBackColor = cGreen

            .SetCell(37, 22, 17, "37").CellBackColor = cGreen
            .SetCell(38, 24, 17, "38").CellBackColor = cGreen
            .SetCell(39, 26, 17, "39").CellBackColor = cRed
            .SetCell(40, 28, 17, "40").CellBackColor = cGreen
            .SetCell(41, 22, 15, "41").CellBackColor = cRed
            .SetCell(42, 24, 15, "42").CellBackColor = cGreen
            .SetCell(43, 26, 15, "43").CellBackColor = cRed
            .SetCell(44, 28, 15, "44").CellBackColor = cGreen
            .SetCell(45, 22, 13, "45").CellBackColor = cRed
            .SetCell(46, 24, 13, "46").CellBackColor = cGreen
            .SetCell(47, 26, 13, "47").CellBackColor = cGreen
            .SetCell(48, 28, 13, "48").CellBackColor = cRed
            .SetCell(49, 22, 11, "49").CellBackColor = cRed
            .SetCell(50, 24, 11, "50").CellBackColor = cGreen
            .SetCell(51, 26, 11, "51").CellBackColor = cGreen
            .SetCell(52, 28, 11, "52").CellBackColor = cGreen
            .SetCell(53, 22, 9, "53").CellBackColor = cGreen
            .SetCell(54, 24, 9, "54").CellBackColor = cRed
            .SetCell(55, 26, 9, "55").CellBackColor = cGreen
            .SetCell(56, 28, 9, "56").CellBackColor = cRed
            .SetCell(57, 22, 7, "57").CellBackColor = cGreen
            .SetCell(58, 24, 7, "58").CellBackColor = cGreen
            .SetCell(59, 26, 7, "59").CellBackColor = cRed
            .SetCell(60, 28, 7, "60").CellBackColor = cGreen

            .SetCell(61, 3, 5, "61s").CellBackColor = cGreen
            .SetCell(62, 5, 5, "62s").CellBackColor = cRed
            .SetCell(63, 7, 5, "63s").CellBackColor = cGreen
            .SetCell(64, 9, 5, "64s").CellBackColor = cGreen

            .SetCell(65, 12, 5, "65s").CellBackColor = cGreen
            .SetCell(66, 14, 5, "66s").CellBackColor = cGreen
            .SetCell(67, 16, 5, "67s").CellBackColor = cGreen
            .SetCell(68, 18, 5, "68s").CellBackColor = cGreen

            .SetCell(69, 21, 5, "69s").CellBackColor = cGreen
            .SetCell(70, 23, 5, "70s").CellBackColor = cRed
            .SetCell(71, 25, 5, "71s").CellBackColor = cRed
            .SetCell(72, 27, 5, "72s").CellBackColor = cRed

            .Redraw()
        End With

    End Sub

    Private Sub CmdActiveDragging_Click(sender As Object, e As EventArgs) Handles CmdActiveDragging.Click
        PsysGridMap1.DraggingActive = True
    End Sub

    Private Sub CmdDeactiveDragging_Click(sender As Object, e As EventArgs) Handles CmdDeactiveDragging.Click
        PsysGridMap1.DraggingActive = False
    End Sub

    Private Sub PsysGridMap1_Dragging(sender As Object, e As EventArgs) Handles PsysGridMap1.Dragging

        Dim CellArgs As PsysCellsEventArgs = TryCast(e, PsysCellsEventArgs)
        If CellArgs Is Nothing Then Return

        Dim MyCell As ClsPsysCell = PsysGridMap1.SetCell(
            newID:=CellArgs.CellX.ToString & "," & CellArgs.CellY.ToString,
            CellX:=CellArgs.CellX,
            CellY:=CellArgs.CellY,
            newTitle:=CellArgs.CellX.ToString & "," & CellArgs.CellY.ToString
        )
        MyCell.CellBackColor = Color.GreenYellow
        MyCell.CornerNote = True
        MyCell.CornerPosition = EnumCornerPosition.RightTop
        MyCell.CornerColor = Color.Red
        PsysGridMap1.Redraw()

    End Sub

    Private Sub PsysGridMap1_CellClick(sender As Object, e As EventArgs) Handles PsysGridMap1.CellClick

        Dim CellArgs As PsysCellsEventArgs = TryCast(e, PsysCellsEventArgs)
        If CellArgs Is Nothing Then Return

        Dim sInfo As String = ""
        sInfo &= "Cell: (X:" & CellArgs.CellX.ToString & ",Y:" & CellArgs.CellY.ToString & ")"
        sInfo &= " - "
        sInfo &= "Mouse: (X:" & CellArgs.MouseX.ToString & ",Y:" & CellArgs.MouseY.ToString & ")"
        txtCellInfo.Text = sInfo

    End Sub

    Private Sub PsysGridMap1_CellDoubleClick(sender As Object, e As EventArgs) Handles PsysGridMap1.CellDoubleClick

        Dim CellArgs As PsysCellsEventArgs = TryCast(e, PsysCellsEventArgs)
        If CellArgs Is Nothing Then Return

        Dim newCell As New ClsPsysCell
        With newCell
            .ID = CellArgs.CellX.ToString & "," & CellArgs.CellY.ToString
            .CellX = CellArgs.CellX
            .CellY = CellArgs.CellY
            .CellBackColor = Color.Yellow
            .CornerNote = True
            .CornerPosition = EnumCornerPosition.LeftTop
            .CornerColor = Color.Red
            .Title = CellArgs.CellX.ToString & "," & CellArgs.CellY.ToString
        End With
        PsysGridMap1.SetCell(newCell)
        PsysGridMap1.Redraw()

    End Sub

    Private Sub CmdLoadUSA_Click(sender As Object, e As EventArgs) Handles CmdLoadUSA.Click

        With PsysGridMap1
            .TotalCellsX = 12
            .TotalCellsY = 8
            .CellWidth = 40
            .CellHeight = 40
            .RemoveAllCells()
            .MapBackgroundImage = Nothing
            .MapBackColor = Color.Azure
            .MapBorderColor = Color.Silver
            .ForeColor = Color.Black
            .BackgroundMapJSON = ""
            .BackgroundMapXML = ""

            .CellsTitleAlign = ContentAlignment.MiddleCenter

            Dim f As New Font(Me.Font.FontFamily, 12, FontStyle.Italic)
            .CellsFont = f

            .SetCell(1, 1, 1, "AK").CellBackColor = RandomColor()
            .SetCell(2, 12, 1, "ME").CellBackColor = RandomColor()
            .SetCell(3, 11, 2, "VT").CellBackColor = RandomColor()
            .SetCell(4, 12, 2, "NH").CellBackColor = RandomColor()

            .SetCell(5, 2, 3, "WA").CellBackColor = RandomColor()
            .SetCell(6, 3, 3, "ID").CellBackColor = RandomColor()
            .SetCell(7, 4, 3, "MT").CellBackColor = RandomColor()
            .SetCell(8, 5, 3, "ND").CellBackColor = RandomColor()
            .SetCell(9, 6, 3, "MN").CellBackColor = RandomColor()
            .SetCell(10, 7, 3, "IL").CellBackColor = RandomColor()
            .SetCell(11, 8, 3, "WI").CellBackColor = RandomColor()
            .SetCell(12, 9, 3, "MI").CellBackColor = RandomColor()
            .SetCell(13, 10, 3, "NY").CellBackColor = RandomColor()
            .SetCell(14, 11, 3, "RI").CellBackColor = RandomColor()
            .SetCell(15, 12, 3, "MA").CellBackColor = RandomColor()

            .SetCell(16, 2, 4, "OR").CellBackColor = RandomColor()
            .SetCell(17, 3, 4, "NV").CellBackColor = RandomColor()
            .SetCell(18, 4, 4, "WY").CellBackColor = RandomColor()
            .SetCell(19, 5, 4, "SD").CellBackColor = RandomColor()
            .SetCell(20, 6, 4, "IA").CellBackColor = RandomColor()
            .SetCell(21, 7, 4, "IN").CellBackColor = RandomColor()
            .SetCell(22, 8, 4, "OH").CellBackColor = RandomColor()
            .SetCell(23, 9, 4, "PA").CellBackColor = RandomColor()
            .SetCell(24, 10, 4, "NJ").CellBackColor = RandomColor()
            .SetCell(25, 11, 4, "CT").CellBackColor = RandomColor()

            .SetCell(26, 2, 5, "CA").CellBackColor = RandomColor()
            .SetCell(27, 3, 5, "UT").CellBackColor = RandomColor()
            .SetCell(28, 4, 5, "CO").CellBackColor = RandomColor()
            .SetCell(29, 5, 5, "NE").CellBackColor = RandomColor()
            .SetCell(30, 6, 5, "MO").CellBackColor = RandomColor()
            .SetCell(31, 7, 5, "KY").CellBackColor = RandomColor()
            .SetCell(32, 8, 5, "WV").CellBackColor = RandomColor()
            .SetCell(33, 9, 5, "VA").CellBackColor = RandomColor()
            .SetCell(34, 10, 5, "MD").CellBackColor = RandomColor()
            .SetCell(35, 11, 5, "DE").CellBackColor = RandomColor()

            .SetCell(36, 3, 6, "AZ").CellBackColor = RandomColor()
            .SetCell(37, 4, 6, "NM").CellBackColor = RandomColor()
            .SetCell(38, 5, 6, "KS").CellBackColor = RandomColor()
            .SetCell(39, 6, 6, "AR").CellBackColor = RandomColor()
            .SetCell(40, 7, 6, "TN").CellBackColor = RandomColor()
            .SetCell(41, 8, 6, "NC").CellBackColor = RandomColor()
            .SetCell(42, 9, 6, "SC").CellBackColor = RandomColor()
            .SetCell(43, 10, 6, "DC").CellBackColor = RandomColor()

            .SetCell(44, 5, 7, "OK").CellBackColor = RandomColor()
            .SetCell(45, 6, 7, "LA").CellBackColor = RandomColor()
            .SetCell(46, 7, 7, "MS").CellBackColor = RandomColor()
            .SetCell(47, 8, 7, "AL").CellBackColor = RandomColor()
            .SetCell(48, 9, 7, "GA").CellBackColor = RandomColor()

            .SetCell(49, 1, 8, "HI").CellBackColor = RandomColor()
            .SetCell(50, 5, 8, "TX").CellBackColor = RandomColor()
            .SetCell(51, 10, 8, "FL").CellBackColor = RandomColor()

            .Redraw()
        End With

    End Sub

    Dim rnd As New Random
    Private Function RandomColor() As Color

        Return Color.FromArgb(255, rnd.Next(255), rnd.Next(255), rnd.Next(255))
    End Function


    Private Sub CmdLoadBeachImage_Click(sender As Object, e As EventArgs) Handles CmdLoadBeachImage.Click

        'Get images from Resource
        Dim imgBeach As Image
        imgBeach = TryCast(My.Resources.ResourceManager.GetObject("imgBeach"), Image)
        Dim imgPosAzure As Image
        imgPosAzure = TryCast(My.Resources.ResourceManager.GetObject("imgPosAzure"), Image)
        Dim imgPosYellow As Image
        imgPosYellow = TryCast(My.Resources.ResourceManager.GetObject("imgPosYellow"), Image)
        Dim imgLettino As Image
        imgLettino = TryCast(My.Resources.ResourceManager.GetObject("imgLettino"), Image)

        'Set GridMap
        With PsysGridMap1
            .TotalCellsX = 28
            .TotalCellsY = 19
            .CellWidth = 35
            .CellHeight = 35
            .RemoveAllCells()
            .MapBackgroundImage = imgBeach
            .ForeColor = Color.Black
            .CellsTitleAlign = ContentAlignment.TopLeft
            Dim f As New Font(Me.Font.FontFamily, 8) ', FontStyle.Bold)
            .CellsFont = f

            '### Load a BackgroundMap from a JSON string ###
            Dim jStr As String = ""
            jStr = jStr + "{" + vbCrLf
            jStr = jStr + "  ""Type"": ""BackGroundMap""," + vbCrLf
            jStr = jStr + "  ""Items"": [" + vbCrLf
            jStr = jStr + "    {""IniPosX"": 1, ""IniPosY"": 19,  ""EndPosX"": 28,  ""EndPosY"": 19,  ""BackColorHTML"": ""#dddddd""}," + vbCrLf
            jStr = jStr + "    {""IniPosX"": 16, ""IniPosY"": 17, ""EndPosX"": 27, ""EndPosY"": 18, ""BackColorHTML"": ""#A97735""}" + vbCrLf
            jStr = jStr + "  ]" + vbCrLf
            jStr = jStr + "}" + vbCrLf
            .BackgroundMapJSON = jStr


            Dim cYellow As Color = Color.FromArgb(180, 200, 200, 0)
            Dim cRed As Color = Color.FromArgb(180, 200, 0, 0)
            Dim cGreen As Color = Color.FromArgb(180, 0, 200, 0)
            Dim iCornSize As Integer = 12

            Dim IdPos As Integer = 0
            For yy = 5 To 17 Step 2
                For xx = 2 To 12 Step 2
                    IdPos += 1
                    Dim oCell As ClsPsysCell
                    oCell = .SetCell(IdPos, xx, yy, IdPos.ToString)
                    oCell.CellBackColor = Nothing
                    oCell.CellBackgroundImage = imgPosAzure
                    oCell.CellBackgroundImagePosition = ContentAlignment.BottomRight
                    oCell.CornerNote = True
                    oCell.CornerColor = cGreen
                    oCell.CornerPosition = EnumCornerPosition.RightTop
                    oCell.CornerSize = 10
                Next
            Next

            For yy = 6 To 7
                For xx = 16 To 21
                    IdPos += 1
                    Dim oCell As ClsPsysCell
                    oCell = .SetCell(IdPos, xx, yy, IdPos.ToString)
                    oCell.CellBackColor = Nothing
                    oCell.CellBackgroundImage = imgLettino
                    oCell.CellBackgroundImagePosition = ContentAlignment.BottomRight
                    oCell.CornerNote = True
                    oCell.CornerColor = cGreen
                    oCell.CornerPosition = EnumCornerPosition.RightTop
                    oCell.CornerSize = 10
                Next
            Next

            For yy = 9 To 15 Step 2
                For xx = 16 To 27
                    IdPos += 1
                    Dim oCell As ClsPsysCell
                    oCell = .SetCell(IdPos, xx, yy, IdPos.ToString)
                    oCell.CellBackColor = Nothing
                    oCell.CellBackgroundImage = imgPosYellow
                    oCell.CellBackgroundImagePosition = ContentAlignment.BottomRight
                    oCell.CornerNote = True
                    oCell.CornerColor = cGreen
                    oCell.CornerPosition = EnumCornerPosition.RightTop
                    oCell.CornerSize = iCornSize
                Next
            Next

            For i = 1 To 50
                Dim Id As Integer = CInt(rnd.Next(80)) + 1
                Dim oCell As ClsPsysCell
                oCell = .GetCell(Id)
                oCell.CornerNote = True
                oCell.CornerColor = cRed
                oCell.CornerPosition = EnumCornerPosition.RightTop
                oCell.CornerSize = iCornSize
            Next

            For i = 1 To 20
                Dim Id As Integer = CInt(rnd.Next(80)) + 1
                Dim oCell As ClsPsysCell
                oCell = .GetCell(Id)
                oCell.CornerNote = True
                oCell.CornerColor = cYellow
                oCell.CornerPosition = EnumCornerPosition.RightTop
                oCell.CornerSize = iCornSize
            Next

            .Redraw()

        End With

    End Sub

End Class